38071367ec6b4acce2ecc55381f26cf2bc07b30c
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
53 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
54 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
55 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
56 recode release sed utils guile perl apache inet"
57
58
59 # these libraries are built for the target environment, and are built after
60 # the host libraries and the host tools (which may be a cross compiler)
61 #
62 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
63
64
65 # these tools are built using the target libs, and are intended to run only
66 # in the target environment
67 #
68 # note: any program that *uses* libraries that are in the "target_libs"
69 # list belongs in this list. those programs are also very likely
70 # candidates for the "native_only" list which follows
71 #
72 target_tools="target-examples target-groff"
73
74 ################################################################################
75
76 ## These two lists are of directories that are to be removed from the
77 ## ${configdirs} list for either cross-compilations or for native-
78 ## compilations. For example, it doesn't make that much sense to
79 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
80 ## a native environment.
81
82 # directories to be built in the native environment only
83 #
84 native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
85 indent ispell m4 rcs recode sed shellutils tar textutils gash
86 uudecode wdiff gprof target-groff guile perl apache inet"
87
88 # directories to be built in a cross environment only
89 #
90 cross_only="target-libiberty target-libgloss target-newlib"
91
92 ## All tools belong in one of the four categories, and are assigned above
93 ## We assign ${configdirs} this way to remove all embedded newlines. This
94 ## is important because configure will choke if they ever get through.
95 ## ${configdirs} is directories we build using the host tools.
96 ## ${target_configdirs} is directories we build using the target tools.
97 #
98 configdirs=`echo ${host_libs} ${host_tools}`
99 target_configdirs=`echo ${target_libs} ${target_tools}`
100
101 ################################################################################
102
103 srctrigger=move-if-change
104 srcname="gnu development package"
105
106 # This gets set non-empty for some net releases of packages.
107 appdirs=""
108
109 # per-host:
110
111 # Work in distributions that contain no compiler tools, like Autoconf.
112 if [ -d ${srcdir}/config ]; then
113 case "${host}" in
114 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
115 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
116 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
117 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
118 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
119 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
120 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
121 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
122 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
123 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
124 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
125 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
126 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
127 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
128 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
129 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
130 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
131 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
132 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
133 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
134 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
135 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
136 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
137 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
138 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
139 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
140 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
141 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
142 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
143 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
144 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
145 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
146 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
147 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
148 esac
149 fi
150
151 # If we aren't going to be using gcc, see if we can extract a definition
152 # of CC from the fragment.
153 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
154 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
155 found=
156 for dir in $PATH; do
157 test -z "$dir" && dir=.
158 if test -f $dir/gcc; then
159 found=yes
160 break
161 fi
162 done
163 IFS="$save_ifs"
164 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
165 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
166 if [ -n "${xx}" ] ; then
167 CC=$xx
168 fi
169 fi
170 fi
171
172 # We default to --with-shared on platforms where -fpic is meaningless.
173 # Well, we don't yet, but we will.
174 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
175 case "${target}" in
176 alpha-dec-osf*) enable_shared=yes ;;
177 alpha-*-linux*) enable_shared=yes ;;
178 mips-sgi-irix5*) enable_shared=yes ;;
179 *) enable_shared=no ;;
180 esac
181 fi
182
183 case "${enable_shared}" in
184 yes) shared=yes ;;
185 no) shared=no ;;
186 "") shared=no ;;
187 *) shared=yes ;;
188 esac
189
190 if [ x${shared} = xyes ]; then
191 waugh=
192 case "${host}" in
193 hppa*) waugh=config/mh-papic ;;
194 i[345]86-*) waugh=config/mh-x86pic ;;
195 sparc64-*) waugh=config/mh-sparcpic ;;
196 *) waugh=config/mh-${host_cpu}pic ;;
197 esac
198 if [ -f ${srcdir}/${waugh} ]; then
199 if [ -n "${host_makefile_frag}" ] ; then
200 cat ${srcdir}/${host_makefile_frag} > mh-frag
201 cat ${srcdir}/${waugh} >> mh-frag
202 host_makefile_frag=mh-frag
203 else
204 host_makefile_frag=${waugh}
205 fi
206 fi
207 fi
208
209 # per-target:
210
211 case "${target}" in
212 v810*) target_makefile_frag=config/mt-v810 ;;
213 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
214 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
215 esac
216
217 skipdirs=
218 gasdir=gas
219 use_gnu_ld=
220 use_gnu_as=
221
222 # some tools are so dependent upon X11 that if we're not building with X,
223 # it's not even worth trying to configure, much less build, that tool.
224
225 case ${with_x} in
226 yes | "") # the default value for this tree is that X11 is available
227 ;;
228 no)
229 skipdirs="${skipdirs} tk gash"
230 ;;
231 *)
232 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
233 ;;
234 esac
235
236 # Some tools are only suitable for building in a "native" situation.
237 # Those are added when we have a host==target configuration. For cross
238 # toolchains, we add some directories that should only be useful in a
239 # cross-compiler.
240
241 is_cross_compiler=
242
243 if [ x"${host}" = x"${target}" ] ; then
244 # when doing a native toolchain, don't build the targets
245 # that are in the 'cross only' list
246 skipdirs="${skipdirs} ${cross_only}"
247 is_cross_compiler=no
248 target_subdir=.
249 else
250 # similarly, don't build the targets in the 'native only'
251 # list when building a cross compiler
252 skipdirs="${skipdirs} ${native_only}"
253 is_cross_compiler=yes
254 target_subdir=${target_alias}
255 if [ ! -d ${target_subdir} ] ; then
256 if mkdir ${target_subdir} ; then true
257 else
258 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
259 exit 1
260 fi
261 fi
262 fi
263
264 copy_dirs=
265
266 # Handle --with-headers=XXX. The contents of the named directory are
267 # copied to $(tooldir)/sys-include.
268 if [ x"${with_headers}" != x ]; then
269 if [ x${is_cross_compiler} = xno ]; then
270 echo 1>&2 '***' --with-headers is only supported when cross compiling
271 exit 1
272 fi
273 case "${exec_prefixoption}" in
274 "") x=${prefix} ;;
275 *) x=${exec_prefix} ;;
276 esac
277 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
278 fi
279
280 # Handle --with-libs=XXX. Multiple directories are permitted. The
281 # contents are copied to $(tooldir)/lib.
282 if [ x"${with_libs}" != x ]; then
283 if [ x${is_cross_compiler} = xno ]; then
284 echo 1>&2 '***' --with-libs is only supported when cross compiling
285 exit 1
286 fi
287 # Copy the libraries in reverse order, so that files in the first named
288 # library override files in subsequent libraries.
289 case "${exec_prefixoption}" in
290 "") x=${prefix} ;;
291 *) x=${exec_prefix} ;;
292 esac
293 for l in ${with_libs}; do
294 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
295 done
296 fi
297
298 # If both --with-headers and --with-libs are specified, default to
299 # --without-newlib.
300 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
301 if [ x"${with_newlib}" = x ]; then
302 with_newlib=no
303 fi
304 fi
305
306 # Recognize --with-newlib/--without-newlib.
307 if [ x${with_newlib} = xno ]; then
308 skipdirs="${skipdirs} target-newlib"
309 elif [ x${with_newlib} = xyes ]; then
310 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
311 fi
312
313 # Default to using --with-stabs for certain targets.
314 if [ x${with_stabs} = x ]; then
315 case "${target}" in
316 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
317 with_stabs=yes;
318 withoptions="${withoptions} --with-stabs"
319 ;;
320 esac
321 fi
322
323 # Handle ${copy_dirs}
324 set fnord ${copy_dirs}
325 shift
326 while [ $# != 0 ]; do
327 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
328 :
329 else
330 echo Copying $1 to $2
331
332 # Use the install script to create the directory and all required
333 # parent directories.
334 if [ -d $2 ]; then
335 :
336 else
337 echo >config.temp
338 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
339 fi
340
341 # Copy the directory, assuming we have tar.
342 # FIXME: Should we use B in the second tar? Not all systems support it.
343 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
344
345 # It is the responsibility of the user to correctly adjust all
346 # symlinks. If somebody can figure out how to handle them correctly
347 # here, feel free to add the code.
348
349 echo $1 > $2/COPIED
350 fi
351 shift; shift
352 done
353
354 # Configure extra directories which are host specific
355
356 case "${host}" in
357 i[345]86-*-go32*)
358 configdirs="$configdirs dosrel" ;;
359 *-cygwin32*)
360 configdirs="$configdirs dosrel" ;;
361 esac
362
363 # Remove more programs from consideration, based on the host or
364 # target this usually means that a port of the program doesn't
365 # exist yet.
366
367 noconfigdirs=""
368
369 case "${host}" in
370 i[345]86-*-vsta)
371 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
372 ;;
373 i[345]86-*-go32)
374 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
375 ;;
376 *-*-cygwin32)
377 noconfigdirs="patch diff tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
378 ;;
379 ppc*-*-pe)
380 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
381 ;;
382 esac
383
384
385 case "${target}" in
386 *-*-netware)
387 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
388 ;;
389 *-*-vxworks*)
390 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
391 ;;
392 *-*-ose)
393 noconfigdirs="$noconfigdirs target-libgloss"
394 ;;
395 alpha-dec-osf*)
396 # ld works, but does not support shared libraries. emacs doesn't
397 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
398 # gas doesn't generate exception information.
399 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
400 ;;
401 alpha*-*-*vms*)
402 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
403 ;;
404 alpha*-*-*)
405 # newlib is not 64 bit ready
406 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
407 ;;
408 # start-sanitize-arc
409 arc-*-*)
410 noconfigdirs="$noconfigdirs target-libgloss"
411 ;;
412 # end-sanitize-arc
413 arm-*-pe*)
414 noconfigdirs="$noconfigdirs target-libgloss"
415 ;;
416 arm-*-riscix*)
417 noconfigdirs="$noconfigdirs ld target-libgloss"
418 ;;
419 h8300*-*-* | \
420 h8500-*-*)
421 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
422 ;;
423 hppa*-*-*elf* | \
424 hppa*-*-lites*)
425 # Do configure ld/binutils/gas for this case.
426 ;;
427 hppa*-*-*)
428 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
429 # cc is gcc, and on any system a user should be able to link cc to
430 # whatever they want. FIXME, emacs emacs19).
431 case "${CC}" in
432 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
433 *) ;;
434 esac
435 noconfigdirs="$noconfigdirs ld shellutils"
436 ;;
437 i[345]86-*-go32)
438 # but don't build gdb
439 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
440 ;;
441 *-*-cygwin32)
442 target_configdirs="$target_configdirs target-winsup"
443 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
444 # always build newlib.
445 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
446
447 # Can't build gdb for cygwin32 if not native.
448 case "${host}" in
449 *-*-cygwin32) ;; # keep gdb
450 *) noconfigdirs="$noconfigdirs gdb"
451 esac
452 ;;
453 i[345]86-*-pe)
454 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
455 ;;
456 i[345]86-*-sco3.2v5*)
457 # The linker does not yet know about weak symbols in COFF,
458 # and is not configured to handle mixed ELF and COFF.
459 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
460 ;;
461 i[345]86-*-sco*)
462 noconfigdirs="$noconfigdirs gprof target-libgloss"
463 ;;
464 i[345]86-*-solaris2*)
465 # The linker does static linking correctly, but the Solaris C library
466 # has bugs such that some important functions won't work when statically
467 # linked. (See man pages for getpwuid, for example.)
468 noconfigdirs="$noconfigdirs ld target-libgloss"
469 ;;
470 i[345]86-*-sysv4*)
471 # The SYSV4 C compiler doesn't handle Emacs correctly
472 case "${CC}" in
473 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
474 *) ;;
475 esac
476 # but that's okay since emacs doesn't work anyway
477 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
478 ;;
479 powerpc-*-aix*)
480 # copied from rs6000-*-* entry
481 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
482 # This is needed until gcc and ld are fixed to work together.
483 use_gnu_ld=no
484 ;;
485 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
486 target_configdirs="$target_configdirs target-winsup"
487 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
488 # always build newlib.
489 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
490 ;;
491 # This is temporary until we can link against shared libraries
492 powerpcle-*-solaris*)
493 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
494 ;;
495 rs6000-*-lynxos*)
496 # The CVS server code doesn't work on the RS/6000
497 # Newlib makes problems for libg++ in crosses.
498 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
499 ;;
500 rs6000-*-aix*)
501 noconfigdirs="$noconfigdirs gprof"
502 # This is needed until gcc and ld are fixed to work together.
503 use_gnu_ld=no
504 ;;
505 rs6000-*-*)
506 noconfigdirs="$noconfigdirs gprof"
507 ;;
508 m68k-apollo-*)
509 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
510 ;;
511 mips*-*-irix5*)
512 # The GNU linker does not support shared libraries.
513 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
514 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
515 ;;
516 mips*-*-irix6*)
517 # The GNU linker does not support shared libraries.
518 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
519 # BFD does not have Irix 6 support yet.
520 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
521 ;;
522 mips*-dec-bsd*)
523 noconfigdirs="$noconfigdirs gprof target-libgloss"
524 ;;
525 mips*-*-bsd*)
526 noconfigdirs="$noconfigdirs gprof target-libgloss"
527 ;;
528 mips*-*-*)
529 noconfigdirs="$noconfigdirs gprof"
530 ;;
531 romp-*-*)
532 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
533 ;;
534 sh-*-*)
535 case "${host}" in
536 i[345]86-*-vsta) ;; # don't add gprof back in
537 i[345]86-*-go32) ;; # don't add gprof back in
538 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
539 esac
540 noconfigdirs="$noconfigdirs target-libgloss"
541 ;;
542 sparc-*-sunos4*)
543 if [ x${is_cross_compiler} != xno ] ; then
544 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
545 else
546 use_gnu_ld=no
547 fi
548 ;;
549 v810-*-*)
550 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
551 ;;
552 vax-*-vms)
553 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
554 ;;
555 vax-*-*)
556 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
557 ;;
558 *-*-lynxos*)
559 # Newlib makes problems for libg++ in crosses.
560 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
561 ;;
562 *-*-macos* | \
563 *-*-mpw*)
564 # Macs want a resource compiler.
565 configdirs="$configdirs grez"
566 ;;
567 esac
568
569 # targets that need a second pass
570 case "${target}" in
571 *-gm-magic*)
572 noconfigdirs="$noconfigdirs target-libgloss"
573 ;;
574 esac
575
576 # If we aren't building newlib, then don't build libgloss, since libgloss
577 # depends upon some newlib header files.
578 case "${noconfigdirs}" in
579 *target-libgloss*) ;;
580 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
581 esac
582
583 # If we are building a Canadian Cross, discard tools that can not be built
584 # using a cross compiler. FIXME: These tools should be fixed.
585 if [ "${build}" != "${host}" ]; then
586 noconfigdirs="$noconfigdirs tcl tk expect dejagnu texinfo"
587 fi
588
589 # Make sure we don't let GNU ld be added if we didn't want it.
590 if [ x$with_gnu_ld = xno ]; then
591 use_gnu_ld=no
592 noconfigdirs="$noconfigdirs ld"
593 fi
594
595 # Make sure we don't let GNU as be added if we didn't want it.
596 if [ x$with_gnu_as = xno ]; then
597 use_gnu_as=no
598 noconfigdirs="$noconfigdirs gas"
599 fi
600
601 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
602 # $target_configdirs.
603 # If we have the source for $noconfigdirs entries, add them to $notsupp.
604
605 notsupp=""
606 for dir in . $skipdirs $noconfigdirs ; do
607 dirname=`echo $dir | sed -e s/target-//g`
608 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
609 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
610 if [ -r $srcdir/$dirname/configure ] \
611 || [ -r $srcdir/$dirname/configure.in ]; then
612 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
613 true
614 else
615 notsupp="$notsupp $dir"
616 fi
617 fi
618 fi
619 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
620 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
621 if [ -r $srcdir/$dirname/configure ] \
622 || [ -r $srcdir/$dirname/configure.in ]; then
623 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
624 true
625 else
626 notsupp="$notsupp $dir"
627 fi
628 fi
629 fi
630 done
631
632 # Sometimes the tools are distributed with libiberty but with no other
633 # libraries. In that case, we don't want to build target-libiberty.
634 if [ -n "${target_configdirs}" ]; then
635 others=
636 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
637 if [ "$i" != "libiberty" ]; then
638 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
639 others=yes;
640 break;
641 fi
642 fi
643 done
644 if [ -z "${others}" ]; then
645 target_configdirs=
646 fi
647 fi
648
649 # Deconfigure all subdirectories, in case we are changing the
650 # configuration from one where a subdirectory is supported to one where it
651 # is not.
652 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
653 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
654 rm -f $i/Makefile
655 done
656 fi
657 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
658 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
659 rm -f ${target_subdir}/$i/Makefile
660 done
661 fi
662
663 # Produce a warning message for the subdirs we can't configure.
664 # This isn't especially interesting in the Cygnus tree, but in the individual
665 # FSF releases, it's important to let people know when their machine isn't
666 # supported by the one or two programs in a package.
667
668 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
669 # If $appdirs is non-empty, at least one of those directories must still
670 # be configured, or we error out. (E.g., if the gas release supports a
671 # specified target in some subdirs but not the gas subdir, we shouldn't
672 # pretend that all is well.)
673 if [ -n "$appdirs" ]; then
674 for dir in $appdirs ; do
675 if [ -r $dir/Makefile.in ]; then
676 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
677 appdirs=""
678 break
679 fi
680 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
681 appdirs=""
682 break
683 fi
684 fi
685 done
686 if [ -n "$appdirs" ]; then
687 echo "*** This configuration is not supported by this package." 1>&2
688 exit 1
689 fi
690 fi
691 # Okay, some application will build, or we don't care to check. Still
692 # notify of subdirs not getting built.
693 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
694 echo " ${notsupp}" 1>&2
695 echo " (Any other directories should still work fine.)" 1>&2
696 fi
697
698 # Set with_gnu_as and with_gnu_ld as appropriate.
699 #
700 # This is done by determining whether or not the appropriate directory
701 # is available, and by checking whether or not specific configurations
702 # have requested that this magic not happen.
703 #
704 # The command line options always override the explicit settings in
705 # configure.in, and the settings in configure.in override this magic.
706 #
707 # If the default for a toolchain is to use GNU as and ld, and you don't
708 # want to do that, then you should use the --without-gnu-as and
709 # --without-gnu-ld options for the configure script.
710
711 if [ x${use_gnu_as} = x ] ; then
712 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
713 with_gnu_as=yes
714 withoptions="$withoptions --with-gnu-as"
715 fi
716 fi
717
718 if [ x${use_gnu_ld} = x ] ; then
719 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
720 with_gnu_ld=yes
721 withoptions="$withoptions --with-gnu-ld"
722 fi
723 fi
724
725 if [ x${shared} = xyes ]; then
726 case "${target}" in
727 hppa*) target_makefile_frag=config/mt-papic ;;
728 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
729 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
730 esac
731 fi
732
733 # post-target:
734
735 # Make sure that the compiler is able to generate an executable. If it
736 # can't, we are probably in trouble. We don't care whether we can run the
737 # executable--we might be using a cross compiler--we only care whether it
738 # can be created. At this point the main configure script has set CC.
739 echo "int main () { return 0; }" > conftest.c
740 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
741 if [ $? = 0 ] && [ -s conftest ]; then
742 :
743 else
744 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
745 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
746 rm -f conftest*
747 exit 1
748 fi
749 rm -f conftest*
750
751 # The Solaris /usr/ucb/cc compiler does not appear to work.
752 case "${host}" in
753 sparc-sun-solaris2*)
754 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
755 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
756 could_use=
757 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
758 if [ -d /opt/cygnus/bin ] ; then
759 if [ "$could_use" = "" ] ; then
760 could_use="/opt/cygnus/bin"
761 else
762 could_use="$could_use or /opt/cygnus/bin"
763 fi
764 fi
765 if [ "$could_use" = "" ] ; then
766 echo "Warning: compilation may fail because you're using"
767 echo "/usr/ucb/cc. You should change your PATH or CC "
768 echo "variable and rerun configure."
769 else
770 echo "Warning: compilation may fail because you're using"
771 echo "/usr/ucb/cc, when you should use the C compiler from"
772 echo "$could_use. You should change your"
773 echo "PATH or CC variable and rerun configure."
774 fi
775 fi
776 ;;
777 esac
778
779 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
780 # binutils tools will find libbfd.so.
781 if [ "${shared}" = "yes" ]; then
782 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
783 Makefile > Makefile.tem
784 rm -f Makefile
785 mv -f Makefile.tem Makefile
786
787 case "${host}" in
788 *-*-hpux*)
789 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
790 Makefile > Makefile.tem
791 rm -f Makefile
792 mv -f Makefile.tem Makefile
793 ;;
794 esac
795 fi
796
797 # Record target_configdirs and the configure arguments in Makefile.
798 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
799 targargs=`echo "${arguments}" | \
800 sed -e 's/--norecursion//' \
801 -e 's/--cache[a-z-]*=[^ ]*//' \
802 -e 's/--ho[a-z-]*=[^ ]*//' \
803 -e 's/--ta[a-z-]*=[^ ]*//'`
804
805 # Passing a --with-cross-host argument lets the target libraries know
806 # whether they are being built with a cross-compiler or being built
807 # native. However, it would be better to use other mechanisms to make the
808 # sorts of decisions they want to make on this basis. Please consider
809 # this option to be deprecated. FIXME.
810 if [ x${is_cross_compiler} = xyes ]; then
811 targargs="--with-cross-host=${host_alias} ${targargs}"
812 fi
813
814 targargs="--host=${target_alias} ${targargs}"
815 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
816 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
817 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
818 Makefile > Makefile.tem
819 rm -f Makefile
820 mv -f Makefile.tem Makefile
821
822 #
823 # Local Variables:
824 # fill-column: 131
825 # End:
826 #
This page took 0.067989 seconds and 4 git commands to generate.